package controller

import (
	"math"
	"strconv"

	"gitlab.com/mbugroup/lti-api.git/internal/modules/inventory/product-stocks/dto"
	service "gitlab.com/mbugroup/lti-api.git/internal/modules/inventory/product-stocks/services"
	validation "gitlab.com/mbugroup/lti-api.git/internal/modules/inventory/product-stocks/validations"
	"gitlab.com/mbugroup/lti-api.git/internal/response"

	"github.com/gofiber/fiber/v2"
	// entity "gitlab.com/mbugroup/lti-api.git/internal/entities"
)

type ProductStockController struct {
	ProductStockService service.ProductStockService
}

func NewProductStockController(productStockService service.ProductStockService) *ProductStockController {
	return &ProductStockController{
		ProductStockService: productStockService,
	}
}

func (u *ProductStockController) GetAll(c *fiber.Ctx) error {
	query := &validation.Query{
		Page:   c.QueryInt("page", 1),
		Limit:  c.QueryInt("limit", 10),
		Search: c.Query("search", ""),
	}

	if query.Page < 1 || query.Limit < 1 {
		return fiber.NewError(fiber.StatusBadRequest, "page and limit must be greater than 0")
	}

	result, totalResults, err := u.ProductStockService.GetAll(c, query)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.SuccessWithPaginate[dto.ProductStockListDTO]{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get all productStocks successfully",
			Meta: response.Meta{
				Page:         query.Page,
				Limit:        query.Limit,
				TotalPages:   int64(math.Ceil(float64(totalResults) / float64(query.Limit))),
				TotalResults: totalResults,
			},
			Data: dto.ToProductStockListDTOs(result),
		})
}

func (u *ProductStockController) GetOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	res, err := u.ProductStockService.GetOne(c, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Retrieved product successfully",
			Data:    dto.ToProductStockDetailDTO(*res),
		})
}
